<template>
  <!-- 所在路段选择弹层 -->
  <SuperTableSelectorDialog
    ref="superTableSelectorDialog"
    :defaultTreeExpandLevel="4"
    :isShow.sync="isShowDialog"
    :isShowSelect="false"
    :isShowTree="false"
    :search-option="optionList"
    :table-data="tableData"
    :table-loading="tableLoading"
    :table-options="tableOptions"
    :tableParams="params"
    :tree-item="treeItem"
    :treeData="orgData"
    :treeTabList="['行政维度']"
    hintLanguage="提示：请在列表中选择事件后，点击确认。"
    isSingleChoice
    select-title-name="所在路段"
    selectKey="eventId"
    selectLabel="roadName"
    title="事件选择"
    v-bind="$attrs"
    width="75%"
    @closed="closed"
    @open="open"
    @tableRefresh="getTableData"
    @treeChange="treeChange"
    v-on="$listeners"
  />
</template>

<script>
import {orgTree} from '@/api/systemInterface'
import {tableData} from '@/api/patrolAndRescue/commandDispatch/eventInquiry'
import {refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import SuperTableSelectorDialog from '@/components/SuperTableSelectorDialog/index.vue'
import {dictionaryEscape, getDictionaryByCode} from '@/utils/dictionary'

export default {
  name: 'EventChoiceDialog',
  components: {SuperTableSelectorDialog},
  props: {
    isShow: {
      default: false,
      type: Boolean
    },
    roadId: {
      default: '',
      type: String
    }
  },
  data() {
    return {
      orgData: [], // 组织树
      optionList: [
        {
          title: '事件类型',
          prop: ['event_Type_'],
          type: 'select',
          option: getDictionaryByCode('sjlx'),
          multiple: false,
          default: true
        },
        {title: '事件来源', prop: ['event_Src_'], type: 'select', option: getDictionaryByCode('sjly'), multiple: false}
        // {title: '所属路段', prop: ['road_Name_'], type: 'input', default: true}
      ],
      tableOptions: [
        {label: '报案电话', minWidth: '30', prop: 'eventTel'},
        {
          label: '事件类型',
          minWidth: '40',
          prop: 'eventType',
          formatter: ({eventType}) => dictionaryEscape('sjlx', eventType) || '-'
        },
        {
          label: '事件来源',
          minWidth: '45',
          prop: 'eventSrc',
          formatter: ({eventSrc}) => dictionaryEscape('sjly', eventSrc) || '-'
        },
        {
          label: '事件等级',
          minWidth: '40',
          prop: 'eventLevel',
          formatter: ({eventLevel}) => eventLevel ? eventLevel + '级' : '-'
        },
        {label: '所属路段', minWidth: '50', prop: 'roadName'},
        {label: '事件编号', minWidth: '50', prop: 'eventNo'}
      ],
      params: {
        pageBean: {pageSize: 20, page: 1, total: 0},
        querys: [
          {operation: 'EQUAL', property: 'event_Type_', value: ''},
          {operation: 'EQUAL', property: 'event_Src_', value: ''},
          {operation: 'LIKE', property: 'road_Name_', value: ''},
          {operation: 'LIKE', property: 'road_id_', value: ''}
        ],
        sorter: []
      },
      tableData: [], // 所在路段数据
      treeItem: {}, // 树选中
      tableLoading: false // 表格loading
    }
  },
  computed: {
    isShowDialog: {
      get() {
        return this.isShow
      },
      set(val) {
        this.$emit('update:isShow', val)
      }
    }
  },
  created() {
    // this.getOrgTreeData()
  },
  methods: {
    // 打开弹层时触发
    open() {
      this.params.querys[3].value = this.roadId
      this.getTableData()
    },

    // 关闭弹层触发
    closed() {
      const {orgData} = this
      // 重置data中的数据
      Object.assign(this.$data, this.$options.data.call(this), {orgData})
      this.treeItem = this.orgData[0] || {}
      setQueryValue(this.params, 'COMPANY_IDS_', this.treeItem?.path || '')
    },

    // 获取公司树
    async getOrgTreeData() {
      let data = await orgTree()
      this.orgData = data.value
      this.treeItem = this.orgData[0] || {}
      setQueryValue(this.params, 'COMPANY_IDS_', this.treeItem?.path || '')
    },

    //获取所在路段列表数据
    async getTableData() {
      console.log(this.params, 'this.params')
      this.tableData = []
      this.tableLoading = true
      const {total = 0, rows = []} = await tableData(refineRequestBody(this.params))
      this.params.pageBean.total = total
      this.tableData = rows.map(i => {
        const {id: eventId, eventNo, eventType, eventSrc, roadName, eventTel} = i
        return {eventId, eventNo, eventType, eventSrc, eventTel, roadName}
      })
      this.tableLoading = false
    },

    // 树改变
    treeChange(treeItem) {
      // 修改对应的字段值
      setQueryValue(this.params, 'COMPANY_IDS_', treeItem?.path || '')
      this.getTableData()
    }
  }
}
</script>

<style lang="scss" scoped>

</style>
